# Lab2
## Zdalny dostęp do systemu:
| SSH ADDR               | MAC WIFI          | MAC ETH           | IP ETH         | Hostname |
| :--------------------- | :---------------- | :---------------- | :------------- | :------- |
| root@185.244.98.2:2301 | 7c:5c:f8:0d:53:72 | c0:3f:d5:67:dd:2d | 192.168.1.100  | ztb01    |
| root@185.244.98.2:2302 | 80:19:34:e6:d7:00 | c0:3f:d5:67:dd:b2 | 192.168.1.134 | ztb02    |
| root@185.244.98.2:2303 | 7c:5c:f8:0d:53:72 | c0:3f:d5:67:dd:2d | 192.168.1.128  | ztb03    |
| root@185.244.98.2:2304 | 80:19:34:e6:d7:00 | c0:3f:d5:67:dd:b2 | 192.168.1.147 | ztb04    |
| root@185.244.98.2:2305 | 7c:5c:f8:0d:53:72 | c0:3f:d5:67:dd:2d | 192.168.1.149  | ztb05    |

## Podłączenie układu BME280 do pinów DevKitNUC magistrali i2c:

![Breadboard BME280](lab2.png "Breadboard NUC+BME280")

TODO: Poprawić schemat (prawidłowe połączenie, zmniejszyć rozmiar, zrobić prawidłowy model SVG złącza NUC dla Fritzing)

## Dodanie BME280 do magistrali i2c:
 ![Ex. add BME280 sensor](bme280_test.gif "Przykład odp. prawidłowo podłączonego sensora BME280")
- Test prawidłowego podłączenia przewodów sensora BME280 z NucDevKit (na magistrali i2c powinno wykryć urządzenie pod adresem 0x76):
 ```bash
modprobe i2c_dev
i2cdetect -y -r 8
 ```
- Aktywacja sterownika IIO dla sensora BME280 (adres 0x76@i2c magistrala 8) w systemie
```bash
modprobe i2c_dev
echo "bme280 0x76" > /sys/bus/i2c/devices/i2c-8/new_device
```
- Test prawidłowej aktywacji sterownika IIO dla sensora BME280 :
```bash
 dmesg | tail
 ls /sys/bus/iio/devices/iio\:device0/
 ```
- Odczytanie wartości temp./ciśnienia/wilgotności:
 ```bash
 cat /sys/bus/iio/devices/iio\:device0/in_temp_input
```
## Odczyt wartości ze sterownika IIO w pythonie
```python
path = "/sys/bus/iio/devices/iio:device0/in_temp_input"
with open(path,'r',encoding = 'utf-8') as f:
    print(f.read())  # read the entire file
```

## Zadanie (5pkt.): 
 Dodać obsługę czujnika BME280 w serwisie MQTT (docker mosquitto z lab.1)
 - nadawać wiadomości MQTT z ustalonym interwałem (np. 5s) w topic 'sensors/bme280/' - aplikacja sensorsBME280.py (1pkt.)
  <img src="img/ztb_lab2_schem_bme280.svg"  width="240">
 - odczytywać własne wiadomości z temp. z MQTT (aplikacja recvBME280.py) (1pkt.)
 - wysłać wiadomości MQTT z aktualną temp., kiedy wykryto opadający zbocze na przycisku (wciśnięcie) (zmodyfikować sendBME280.py, tak aby odbierał wiadomości MQTT wysyłane z aplikacji button.py z lab1) (1pkt.)
  <img src="img/ztb_lab2_schem_bme280_button.svg"  width="240">
 - odczytać wiadomości z temp. z innych DevKitNUC (zmodyfikować recvBME280.py, tak aby dobierał wiadomości z kliku kanałów MQTT) (1pkt.)
    <img src="img/ztb_lab2_schem_bme280_button_otherNUC.svg"  width="240">
- utwórz aplikacje alarmTemp.py: odczytuj wiadomości z topic 'sensors/bme280', gdy temp>28st to zapal LED wysyłając wiadomości na topic 'led/490'),gdy temp.<28st. LED wygaszona, skorzystaj z apliakacji led.py z lab1 (1pkt.)
    <img src="img/ztb_lab2_schem_bme280_alarm.svg"  width="240">

## Utworzyć nowe oraz uruchomić kontenery Telegraf, Influx, Grafana
### Telegraf
![Docker telegraf](dockertelegrafS2.gif "Przykład prawidłowego utworzenie i uruchomienie kontenera telegraf")
- Utworzenie kontenera

    UWAGA: przed uruchomieniem komendy '''docker create ...''' w katalogu projektu musi znajdować się plik konfiguracyjny [telegraf.conf](telegraf.conf). Proszę zaznajomić sie z jego zawartością.
```bash
docker pull telegraf
 docker rm telegraf
docker create  -v $(pwd)/:/etc/telegraf:ro --name telegraf telegraf
```
 - Start kontenera
```bash
docker start telegraf
```
 - Podłączenie do uruchomionego kontenera w celu obserwacji wyjście (output)
```bash
docker attach telegraf
```
 - Restart (tylko jeśli zachodzi potrzeba aktualizacji pliku [telegraf.conf](telegraf.conf))
```bash
docker restart telegraf
```
### Influx
![Docker Influx](dockerInfulxS.gif "Przykład prawidłowego utworzenie i uruchomienie kontenera influxdb")
- Utworzenie
 ```bash
docker pull influxdb
docker rm influxdb
docker create -p 8086:8086 -v influxdb:/var/lib/influxdb --name influxdb influxdb
docker run --rm \
      -e INFLUXDB_DB=sensors -e INFLUXDB_ADMIN_ENABLED=true \
      -e INFLUXDB_ADMIN_USER=admin -e INFLUXDB_ADMIN_PASSWORD=ztb123 \
      -e INFLUXDB_USER=telegraf -e INFLUXDB_USER_PASSWORD=telegraf \
      -v influxdb:/var/lib/influxdb \
      influxdb /init-influxdb.sh

```
- Start kontenera
```bash
docker start influxdb
```
 - Podłączenie do uruchomionego kontenera w celu obserwacji wyjście (output)
```bash
docker attach influxdb
```


### Grafana
 - Utworzenie 
```bash
docker pull grafana/grafana
docker rm grafana 
docker volume create grafana-storage
docker create -p 3000:3000 --name=grafana -v grafana-storage:/var/lib/grafana -e "GF_SECURITY_ADMIN_PASSWORD=ztb123" -e "GF_AUTH_ANONYMOUS_ENABLED=TRUE" -e "GF_AUTH_ANONYMOUS_ORG_NAME=GUT" -e "GR_AUTH_DISABLE_LOGIN_FORM=TRUE" grafana/grafana
```
 - Start kontenera grafana
```bash
docker start grafana
```
 - Podłączenie do uruchomionego kontenera w celu obserwacji wyjście (std.output)
```bash
docker attach grafana
```
- Test uruchomionych kontenerów
```bash
docker ps
```
![Docker TIG](tig.gif "Przykład prawidłowego utworzenie i uruchomienie kontenerów TIG")

 - Podłączenie do interfejsu www Grafana:
   http://Adres_IP_NUC:3000

  ![WWW GRAFANA](grafanaustawieniaDB.png "Interfejs www Grafana")

### Zadania (2pkt.):
- Konfiguracja Grafany w celu wyświetlenia danych pomiarowych (1pkt.):
  - Skonfiguruj połączenie z bazą influx
  - Utwórz nowy dashboard wyświetlający temp.

- Skonfiguruj Telegraf w taki sposób, aby pobierał dane pomiarowych MQTT z innych DevNuc - zmodyfikuj (1pkt.) 


## Czytnik NFC

Sprawdz switch 
![Schemat połączenia czytnika NFC z NUC](lab2_nfc.png "Schemat połączenia czytnika NFC z NUC")
TODO: Poprawić schemat+ Rys z ustawieniem switch

- Sprawdzenie poprawnej komunikacji z NF532 na magistrali I2C
```bash
modprobe i2c_dev
i2cdetect -y -r 8
cat /etc/nfc/libnfc.conf
nfc-list
nfc-poll
``` 
Zawartość pliku /etc/nfc/libnfc.conf
````bash
device.name = "PN532 over I2C"
device.connstring = "pn532_i2c:/dev/i2c-1"
````
Po uruchomieniu komendy 'nfc-pool' przyłóż kartę NFC do czytnika, powinien wyświetlić się UID karty.
![Test połączenia czytnika NFC z NUC](PN532_testS.gif "Test połączenia czytnika NFC z NUC")

### Obsługa czytnika w Pythonie:
- Instalacja biblioteki py532lib:
```bash
source virtenv/bin/activate
pip install py532lib
``` 

- Przykładowy kod programu:
```python
from py532lib.i2c import *
from py532lib.frame import *
from py532lib.constants import *

pn532 = Pn532_i2c(i2c_channel=8)
pn532.SAMconfigure()

while(True):
    card_data = pn532.read_mifare().get_data()
    print(card_data)
```
![Test odczytu kart NFC w app python](PN532_python_test.gif "Test odczytu kart NFC w app python")

### Zadania (3pkt.):
 - Dodać obsługę czytnika NFC do MQTT - aplikacja nfcReader.py (topic 'sensors/nfc') (1pkt.) 
 - Zmieć diodę LED na ON (na 5s) kiedy odczyta znaną kartę NFC, brak reakcji na inne karty- aplikacja recvNfc.py odbiera wiadomości z topis 'sensors/nfc' i ustawia diode w topicu 'led/490' (1pkt.)
 - j.w włączyć/wyłączyć diodę na innym NUCDevKit (1pkt.)




